Debian Bug report logs - #500740
Some variables don't default correctly

version graph

Package: live-helper; Maintainer for live-helper is Debian Live Project <debian-live@lists.debian.org>;

Reported by: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>

Date: Tue, 30 Sep 2008 22:51:02 UTC

Severity: normal

Tags: moreinfo, unreproducible

Found in version live-helper/1.0.1-1

Fixed in version live-helper/1.0.1-2

Done: Daniel Baumann <daniel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Tue, 30 Sep 2008 22:51:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>:
New Bug report received and forwarded. Copy sent to Debian Live <debian-live@lists.debian.org>. (Tue, 30 Sep 2008 22:51:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>
To: submit@bugs.debian.org
Cc: jcristau@debian.org
Subject: Some variables don't default correctly
Date: Wed, 01 Oct 2008 00:48:03 +0200
[Message part 1 (text/plain, inline)]
Package: live-helper
Version: 1.0.1-1

Hi,

I'm currently attempting  to build a Debian Live-CD  and leave most of
the  configuration variables  undefined.  Unfortunately,  this doesn't
work -- some of the variables are not defaulted correctly.

When LH_UNION_FILESYSTEM and LH_LINUX_PACKAGES are left undefined, the
build process breaks with

  D: Executing: xargs --arg-file=/root/chroot_packages apt-get --yes install
  Reading package lists... Done
  Building dependency tree... Done
  E: Regex compilation error - Invalid preceding regular expression

The chroot/root/chroot_packages files starts with the following:

  linux-image-2.6-486
  ${LH_UNION_FILESYSTEM}-modules-2.6-486
  squashfs-modules-2.6-486
  linux-image-2.6-686
  ${LH_UNION_FILESYSTEM}-modules-2.6-686
  squashfs-modules-2.6-686
  auto

This was fixed by explicitly saying

  LH_UNION_FILESYSTEM="aufs"
  LH_LINUX_PACKAGES="linux-image-2.6 ${LH_UNION_FILESYSTEM}-modules-2.6 squashfs-modules-2.6"

At that point, Apt complainded about being unable to find the package
``auto'', which was fixed by saying

  LH_INITRAMFS="auto"

I'm not kidding.

                                        Juliusz


[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Wed, 01 Oct 2008 13:45:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 01 Oct 2008 13:45:15 GMT) Full text and rfc822 format available.

Message #10 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>, 500740@bugs.debian.org
Cc: jcristau@debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Wed, 01 Oct 2008 15:44:14 +0200
Juliusz Chroboczek wrote:
> When LH_UNION_FILESYSTEM and LH_LINUX_PACKAGES are left undefined

how are you *exactely* constructing a situation where they are undefined?

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Wed, 01 Oct 2008 14:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 01 Oct 2008 14:18:04 GMT) Full text and rfc822 format available.

Message #15 received at 500740@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: daniel@debian.org, 500740@bugs.debian.org
Cc: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Wed, 1 Oct 2008 16:15:28 +0200
On Wed, Oct  1, 2008 at 15:44:14 +0200, Daniel Baumann wrote:

> Juliusz Chroboczek wrote:
> > When LH_UNION_FILESYSTEM and LH_LINUX_PACKAGES are left undefined
> 
> how are you *exactely* constructing a situation where they are undefined?
> 
We're only defining in config/* the variables for which we don't want to
use the default values, and relying on lh_build to define the rest if it
needs them.  For some reason it doesn't do that, and wants some stuff to
be defined anyway, even if it's unchanged from what lh_config says is
the default.

Cheers,
Julien




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Wed, 01 Oct 2008 15:12:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Cyril Brulebois <cyril.brulebois@kerlabs.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 01 Oct 2008 15:12:06 GMT) Full text and rfc822 format available.

Message #20 received at 500740@bugs.debian.org (full text, mbox):

From: Cyril Brulebois <cyril.brulebois@kerlabs.com>
To: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>, jcristau@debian.org, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Wed, 1 Oct 2008 17:07:05 +0200
[Message part 1 (text/plain, inline)]
Juliusz Chroboczek (01/10/2008):
> When LH_UNION_FILESYSTEM and LH_LINUX_PACKAGES are left undefined,
> the build process breaks with
>
>   D: Executing: xargs --arg-file=/root/chroot_packages apt-get --yes
> install Reading package lists... Done
>   Building dependency tree... Done
>   E: Regex compilation error - Invalid preceding regular expression

Reminds me of #490290.

-- 
Cyril Brulebois
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Wed, 01 Oct 2008 16:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Brendan Sleight" <bms@barwap.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 01 Oct 2008 16:09:02 GMT) Full text and rfc822 format available.

Message #25 received at 500740@bugs.debian.org (full text, mbox):

From: "Brendan Sleight" <bms@barwap.com>
To: 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Wed, 1 Oct 2008 17:06:11 +0100
Hi Julien,

On 01/10/2008, Julien Cristau  wrote:
> > > When LH_UNION_FILESYSTEM and LH_LINUX_PACKAGES are left undefined
> >
> > how are you *exactely* constructing a situation where they are undefined?
> >
> We're only defining in config/* the variables for which we don't want to

I am confused - what are the actually commands used to get to this point ?

Regards,
Brendan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Wed, 01 Oct 2008 17:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tzafrir Cohen <tzafrir.cohen@xorcom.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 01 Oct 2008 17:06:02 GMT) Full text and rfc822 format available.

Message #30 received at 500740@bugs.debian.org (full text, mbox):

From: Tzafrir Cohen <tzafrir.cohen@xorcom.com>
To: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Wed, 1 Oct 2008 20:04:55 +0300
Your reports sound all to familiar.

http://lists.alioth.debian.org/pipermail/debian-live-devel/2007-December/002937.html

(1) and (4) has since been fixed. (2)3 and (3) are this bug.

-- 
               Tzafrir Cohen
icq#16849755              jabber:tzafrir.cohen@xorcom.com
+972-50-7952406           mailto:tzafrir.cohen@xorcom.com
http://www.xorcom.com  iax:guest@local.xorcom.com/tzafrir




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Wed, 01 Oct 2008 17:24:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Chris Lamb <chris@chris-lamb.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 01 Oct 2008 17:24:05 GMT) Full text and rfc822 format available.

Message #35 received at 500740@bugs.debian.org (full text, mbox):

From: Chris Lamb <chris@chris-lamb.co.uk>
To: Tzafrir Cohen <tzafrir.cohen@xorcom.com>, 500740@bugs.debian.org
Cc: 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Wed, 1 Oct 2008 18:23:57 +0100
[Message part 1 (text/plain, inline)]
Tzafrir Cohen wrote:

> Your reports sound all to familiar.

I don't remember seeing this post before. Why didn't you file these as
actual bug reports?


Regards,

-- 
Chris Lamb, UK                                     chris@chris-lamb.co.uk
                                                          GPG: 0x634F9A20
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Sun, 12 Oct 2008 08:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Sun, 12 Oct 2008 08:57:03 GMT) Full text and rfc822 format available.

Message #40 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 500740@bugs.debian.org, 500740-submitter@bugs.debian.org
Subject: Re: Some variables don't default correctly
Date: Sun, 12 Oct 2008 10:53:29 +0200
tags 500740 +unreproducible
tags 500740 +moreinfo
thanks

Guys,

can you *please* show *exactely* how you construct a situation where
this can happen (withouth manual ovveride). also see #490290.

Regards,
Daniel

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Tags added: unreproducible Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Sun, 12 Oct 2008 08:57:04 GMT) Full text and rfc822 format available.

Tags added: moreinfo Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Sun, 12 Oct 2008 08:57:05 GMT) Full text and rfc822 format available.

Message sent on to Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>:
Bug#500740. (Sun, 12 Oct 2008 08:57:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Sun, 12 Oct 2008 10:18:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tzafrir Cohen <tzafrir.cohen@xorcom.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Sun, 12 Oct 2008 10:18:03 GMT) Full text and rfc822 format available.

Message #52 received at 500740@bugs.debian.org (full text, mbox):

From: Tzafrir Cohen <tzafrir.cohen@xorcom.com>
To: daniel@debian.org, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Sun, 12 Oct 2008 12:17:21 +0200
On Sun, Oct 12, 2008 at 10:53:29AM +0200, Daniel Baumann wrote:
> tags 500740 +unreproducible
> tags 500740 +moreinfo
> thanks
> 
> Guys,
> 
> can you *please* show *exactely* how you construct a situation where
> this can happen (withouth manual ovveride). also see #490290.

I posted a link to patches I posted on the list half a year ago. A quick
glance shows that the problems still stand today.

To reproduce you need to avoid using the default configuration. That is:
assume that a variable is not set at all. Rather, set by
/usr/share/live-helper/functions/defaults.sh .

-- 
               Tzafrir Cohen
icq#16849755              jabber:tzafrir.cohen@xorcom.com
+972-50-7952406           mailto:tzafrir.cohen@xorcom.com
http://www.xorcom.com  iax:guest@local.xorcom.com/tzafrir




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Sun, 12 Oct 2008 10:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Sun, 12 Oct 2008 10:51:02 GMT) Full text and rfc822 format available.

Message #57 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Tzafrir Cohen <tzafrir.cohen@xorcom.com>, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Sun, 12 Oct 2008 12:47:47 +0200
Tzafrir Cohen wrote:
> I posted a link to patches I posted on the list half a year ago. A quick
> glance shows that the problems still stand today.
> 
> To reproduce you need to avoid using the default configuration. That is:
> assume that a variable is not set at all. Rather, set by
> /usr/share/live-helper/functions/defaults.sh .

I'm very well aware that *if* the variable is empty, then there's that
problem. however, and that is the point - how do you create a situation
where it is empty (without manual override)?

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Sun, 12 Oct 2008 11:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tzafrir Cohen <tzafrir.cohen@xorcom.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Sun, 12 Oct 2008 11:15:04 GMT) Full text and rfc822 format available.

Message #62 received at 500740@bugs.debian.org (full text, mbox):

From: Tzafrir Cohen <tzafrir.cohen@xorcom.com>
To: Daniel Baumann <daniel@debian.org>, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Sun, 12 Oct 2008 13:11:38 +0200
On Sun, Oct 12, 2008 at 12:47:47PM +0200, Daniel Baumann wrote:
> Tzafrir Cohen wrote:
> > I posted a link to patches I posted on the list half a year ago. A quick
> > glance shows that the problems still stand today.
> > 
> > To reproduce you need to avoid using the default configuration. That is:
> > assume that a variable is not set at all. Rather, set by
> > /usr/share/live-helper/functions/defaults.sh .
> 
> I'm very well aware that *if* the variable is empty, then there's that
> problem. however, and that is the point - how do you create a situation
> where it is empty (without manual override)?

In my case:

I maintain the configuration directory under version control. The old
values that lh_config once generated make little sense to me. Many of
them have changed over time anyway.

Or is lh_config the only supported interface? and manual tweaks are not
allowed?

-- 
               Tzafrir Cohen
icq#16849755              jabber:tzafrir.cohen@xorcom.com
+972-50-7952406           mailto:tzafrir.cohen@xorcom.com
http://www.xorcom.com  iax:guest@local.xorcom.com/tzafrir




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Sun, 12 Oct 2008 11:30:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Sun, 12 Oct 2008 11:30:02 GMT) Full text and rfc822 format available.

Message #67 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Tzafrir Cohen <tzafrir.cohen@xorcom.com>
Cc: 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Sun, 12 Oct 2008 13:26:35 +0200
Tzafrir Cohen wrote:
> I maintain the configuration directory under version control. The old
> values that lh_config once generated make little sense to me. Many of
> them have changed over time anyway.

that's manual overriding of variables then.

> Or is lh_config the only supported interface? and manual tweaks are not
> allowed?

yes. you should *either* only change settings with lh_config *or* know
what you do/keep the config consistent yourself.

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Sun, 12 Oct 2008 22:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Will Murnane" <will.murnane@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Sun, 12 Oct 2008 22:00:03 GMT) Full text and rfc822 format available.

Message #72 received at 500740@bugs.debian.org (full text, mbox):

From: "Will Murnane" <will.murnane@gmail.com>
To: "Tzafrir Cohen" <tzafrir.cohen@xorcom.com>, 500740@bugs.debian.org
Cc: "Daniel Baumann" <daniel@debian.org>
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Sun, 12 Oct 2008 17:52:35 -0400
On Sun, Oct 12, 2008 at 07:11, Tzafrir Cohen <tzafrir.cohen@xorcom.com> wrote:
> I maintain the configuration directory under version control. The old
> values that lh_config once generated make little sense to me. Many of
> them have changed over time anyway.
For the record, I store a Makefile and a shell script in my personal
Subversion repository.  The Makefile cleans the build dir entirely,
then the shell script runs lh_config several times.  Finally, a
tarball is unpacked, which contains the config/chroot_local_includes
directory and some others.  This approach has worked pretty well for
me; it hasn't broken over several iterations of live-helper.

Will




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Mon, 13 Oct 2008 08:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Mon, 13 Oct 2008 08:36:03 GMT) Full text and rfc822 format available.

Message #77 received at 500740@bugs.debian.org (full text, mbox):

From: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>
To: daniel@debian.org
Cc: 500740-quiet@bugs.debian.org, 500740@bugs.debian.org, 500740-submitter@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Mon, 13 Oct 2008 10:29:09 +0200
[Message part 1 (text/plain, inline)]
> can you *please* show *exactely* how you construct a situation where
> this can happen (withouth manual ovveride). also see #490290.

Let me state once again that we are *not* using the lh_config script, but
building the config directory with our own script[1].

Our script does not set all of the LH_* variables, but lets lh_build
default a number of values.  Lh_build is clearly designed to allow this,
but has a number of bugs that make it to default values incorrectly.

LH_INITRAMFS is defaulted incorrectly because of the ``else'' at line 130
of defaults.sh.

LH_LINUX_PACKAGES is defaulted incorrectly because of incorrect quoting at
line 448 of defaults.sh.

Regards,

                                        Juliusz

[1] In case you're into that kind of thing, it is available on

      http://www.pps.jussieu.fr/~jch/software/repos/juppix/makejuppix.sh

    Beware, it's buggy right now.
[Message part 2 (application/pgp-signature, inline)]

Information stored :
Bug#500740; Package live-helper. (Mon, 13 Oct 2008 08:36:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>:
Extra info received and filed, but not forwarded. (Mon, 13 Oct 2008 08:36:06 GMT) Full text and rfc822 format available.

Message sent on to Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>:
Bug#500740. (Mon, 13 Oct 2008 08:36:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Mon, 13 Oct 2008 12:00:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to tomas@tuxteam.de:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Mon, 13 Oct 2008 12:00:11 GMT) Full text and rfc822 format available.

Message #90 received at 500740@bugs.debian.org (full text, mbox):

From: tomas@tuxteam.de
To: Tzafrir Cohen <tzafrir.cohen@xorcom.com>, 500740@bugs.debian.org
Cc: Daniel Baumann <daniel@debian.org>
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Mon, 13 Oct 2008 14:12:38 +0200
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

On Sun, Oct 12, 2008 at 01:11:38PM +0200, Tzafrir Cohen wrote:

[...]

> In my case:
> 
> I maintain the configuration directory under version control. The old
> values that lh_config once generated make little sense to me. Many of
> them have changed over time anyway.
> 
> Or is lh_config the only supported interface? and manual tweaks are not
> allowed?

I stumbled across this one as well. I try to diff what lh_config
produces against my "old" tweaked config directory structure.

Perhaps we need something similar to the kernel's "make oldconfig"? Just
musing...

Regards
- -- tomás
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFI8zs2Bcgs9XrR2kYRApLsAJ9BuGAYVA23J6IQmb6k+sFyAt6aHwCfUTGK
k+WebfKlYx/1UFbzumEzL44=
=UZ/8
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Mon, 13 Oct 2008 12:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tzafrir Cohen <tzafrir.cohen@xorcom.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Mon, 13 Oct 2008 12:33:03 GMT) Full text and rfc822 format available.

Message #95 received at 500740@bugs.debian.org (full text, mbox):

From: Tzafrir Cohen <tzafrir.cohen@xorcom.com>
To: 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Mon, 13 Oct 2008 14:30:10 +0200
On Sun, Oct 12, 2008 at 01:26:35PM +0200, Daniel Baumann wrote:
> Tzafrir Cohen wrote:
> > I maintain the configuration directory under version control. The old
> > values that lh_config once generated make little sense to me. Many of
> > them have changed over time anyway.
> 
> that's manual overriding of variables then.
> 
> > Or is lh_config the only supported interface? and manual tweaks are not
> > allowed?
> 
> yes. you should *either* only change settings with lh_config *or* know
> what you do/keep the config consistent yourself.

We had a small chat on that yesterday, so it can help to clear some
misunderstandings:

The simplest test case here is running 'lh_build' in an empty directory
(no configuration). This will fail at lh_chroot_install-packages because
the list of packages to install includes the two:

  ${LH_UNION_FILESYSTEM}-modules-2.6-amd64
  auto

To which both Daniel Bauman and Chris Lamb claimed that an empty
configuration is invalid, because it has not been blessed by running
lh_config on it.

I consider this a bug. In order to resolve this I would suggest to set
some variable in lh_config before calling Set_defaults . That would
allow Set_defaults to make more informed decisions and specifically
avoid those two issues.

I'm not actively working on debian-live nowadays. So I guess I won't be
get to actually write this soon. I hope someone will beat me to it.

-- 
               Tzafrir Cohen
icq#16849755              jabber:tzafrir.cohen@xorcom.com
+972-50-7952406           mailto:tzafrir.cohen@xorcom.com
http://www.xorcom.com  iax:guest@local.xorcom.com/tzafrir




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Mon, 13 Oct 2008 20:51:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Mon, 13 Oct 2008 20:51:04 GMT) Full text and rfc822 format available.

Message #100 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Tzafrir Cohen <tzafrir.cohen@xorcom.com>, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Mon, 13 Oct 2008 22:48:17 +0200
Tzafrir Cohen wrote:
> The simplest test case here is running 'lh_build' in an empty directory
> (no configuration).

note that this has never been meant to be working; you are always
supposed to run lh_config before lh_build. i'll add a check so that any
helper will fail immediately if there's no config directory available.

> This will fail at lh_chroot_install-packages because
> the list of packages to install includes the two:
> 
>   ${LH_UNION_FILESYSTEM}-modules-2.6-amd64
>   auto
> 
> To which both Daniel Bauman and Chris Lamb claimed that an empty
> configuration is invalid, because it has not been blessed by running
> lh_config on it.

that is not true. i only said that in the case of LH_INITRAMFS, this is
a cosmetic bug that it enforces having run lh_config before build. this
is not trivial to solve (as far as i can see, it's not fixable at all
given that we want the auto value to be expanded at runtime, hence the
check for config in each helper soon). however, LH_LINUX_PACKAGES
handling is still correct as it is.

> I consider this a bug. In order to resolve this I would suggest to set
> some variable in lh_config before calling Set_defaults . That would
> allow Set_defaults to make more informed decisions and specifically
> avoid those two issues.

i don't think this is a sane solution.

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Mon, 13 Oct 2008 20:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Mon, 13 Oct 2008 20:54:03 GMT) Full text and rfc822 format available.

Message #105 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>, 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Mon, 13 Oct 2008 22:50:55 +0200
Juliusz Chroboczek wrote:
> Let me state once again that we are *not* using the lh_config script, but
> building the config directory with our own script[1].

you shall be using lh_config, and anything else is not supported.

> Our script does not set all of the LH_* variables, but lets lh_build
> default a number of values.  Lh_build is clearly designed to allow this,
> but has a number of bugs that make it to default values incorrectly.

it's not - it just happens to be mostly doing the right thing most of
the time.

> LH_INITRAMFS is defaulted incorrectly because of the ``else'' at line 130
> of defaults.sh.

nope; the idea is to have the value 'auto' expanded at runtime.

> LH_LINUX_PACKAGES is defaulted incorrectly because of incorrect quoting at
> line 448 of defaults.sh.

same here. this is on purpose.

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Tue, 14 Oct 2008 14:33:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tzafrir Cohen <tzafrir.cohen@xorcom.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Tue, 14 Oct 2008 14:33:07 GMT) Full text and rfc822 format available.

Message #110 received at 500740@bugs.debian.org (full text, mbox):

From: Tzafrir Cohen <tzafrir.cohen@xorcom.com>
To: 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Tue, 14 Oct 2008 16:28:34 +0200
On Sun, Oct 12, 2008 at 05:52:35PM -0400, Will Murnane wrote:
> On Sun, Oct 12, 2008 at 07:11, Tzafrir Cohen <tzafrir.cohen@xorcom.com> wrote:
> > I maintain the configuration directory under version control. The old
> > values that lh_config once generated make little sense to me. Many of
> > them have changed over time anyway.
> For the record, I store a Makefile and a shell script in my personal
> Subversion repository.  The Makefile cleans the build dir entirely,
> then the shell script runs lh_config several times.  

Why do you run it several times? Shouldn't once be enough?

> Finally, a
> tarball is unpacked, which contains the config/chroot_local_includes
> directory and some others.  This approach has worked pretty well for
> me; it hasn't broken over several iterations of live-helper.

-- 
               Tzafrir Cohen
icq#16849755              jabber:tzafrir.cohen@xorcom.com
+972-50-7952406           mailto:tzafrir.cohen@xorcom.com
http://www.xorcom.com  iax:guest@local.xorcom.com/tzafrir




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Tue, 14 Oct 2008 18:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Tue, 14 Oct 2008 18:42:03 GMT) Full text and rfc822 format available.

Message #115 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 500740@bugs.debian.org
Subject: Re: Bug#500740: Some variables don't default correctly
Date: Tue, 14 Oct 2008 20:38:14 +0200
Tzafrir Cohen wrote:
> Why do you run it several times? Shouldn't once be enough?

for the records: due to the fact that some defaults are conditional on
others, you don't get the same in all cases if you run it once compared
to multiple runs.

therefore, lh_config should be called only once if possible.

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#500740; Package live-helper. (Tue, 14 Oct 2008 19:36:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Tue, 14 Oct 2008 19:36:03 GMT) Full text and rfc822 format available.

Message #120 received at 500740@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 500740@bugs.debian.org
Subject: Re: Some variables don't default correctly
Date: Tue, 14 Oct 2008 21:33:57 +0200
tags 500740 +pending
thanks

workarounded in git by enforcing lh_config to be run before lh_build.
-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Tags added: pending Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Tue, 14 Oct 2008 19:36:04 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Tue, 11 Nov 2008 13:33:24 GMT) Full text and rfc822 format available.

Notification sent to Juliusz Chroboczek <Juliusz.Chroboczek@pps.jussieu.fr>:
Bug acknowledged by developer. (Tue, 11 Nov 2008 13:33:24 GMT) Full text and rfc822 format available.

Message #127 received at 500740-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 500740-close@bugs.debian.org
Subject: Bug#500740: fixed in live-helper 1.0.1-2
Date: Tue, 11 Nov 2008 13:02:03 +0000
Source: live-helper
Source-Version: 1.0.1-2

We believe that the bug you reported is fixed in the latest version of
live-helper, which is due to be installed in the Debian FTP archive:

live-helper_1.0.1-2.diff.gz
  to pool/main/l/live-helper/live-helper_1.0.1-2.diff.gz
live-helper_1.0.1-2.dsc
  to pool/main/l/live-helper/live-helper_1.0.1-2.dsc
live-helper_1.0.1-2_all.deb
  to pool/main/l/live-helper/live-helper_1.0.1-2_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 500740@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-helper package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 11 Nov 2008 13:00:00 +0100
Source: live-helper
Binary: live-helper
Architecture: source all
Version: 1.0.1-2
Distribution: unstable
Urgency: medium
Maintainer: Debian Live <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-helper - Debian Live build scripts
Closes: 498385 499625 499656 499793 500677 500740 501652 502877
Changes: 
 live-helper (1.0.1-2) unstable; urgency=medium
 .
   [ An-Cheng Huang ]
   * ignore harmless warnings from parted.
 .
   [ Chris Lamb ]
   * Really fix LH_BOOTSTRAP="copy". Thanks to Andreas Teuchert
     <ant+bdo@hsg-kl.de>. (Closes: #498385)
   * Ensure local packages lists are sourced over global ones (Closes: #499656)
   * Fix timing issue in create of source tarballs. Patch by Sebastian H
     <shbugreport@online.de>. (Closes: #499793)
   * Additionally save the 'scripts/' subdirectory if it contains files when
     building source images.
   * Syncing options in lh_config(1) with lh_config, etc. Thanks to Luca Bruno.
   * Create a "missing-source.txt" file containing missing source packages
     instead of exiting.
   * Don't build up source package list inside chroot.
   * Install appropriate tasksel program.
   * Correcting sparc architecture detection to ensure correct source package
     contents.
   * Include source for sparc-utils on that architecture.
   * Ensure all files installed via chroot_local-includes are owned by root:root.
     Thanks to Julien Cristau <jcristau@debian.org>.
   * For consistency, don't preserve uid/gid for files in binary_local-includes.
   * Add utility function to call 'Exit' when script exits.
   * Print message when Exit is called.
   * Setup cleanup hook in the high-level helpers.
   * Refactor utility to locate conffiles.
   * Add utility to dump specified file to stdout.
   * Add utility to dump all conffiles to stdout.
   * Add lh_dumpconfig helper to print suitable output for pastebins and other
     remote debugging.
 .
 .
   [ Daniel Baumann ]
   * Adding explicit --yes to apt-get call when installing keyring packages
     (previously, this was inherited through Apt(); wrapper) (Closes: #499625).
   * Correcting wrong spelling of sl-modem-daemon in rescue list.
   * Fixing bcm43xx-fwcutter entry in rescue list, only available in etch.
   * Automatically correct LH_SETUP value if the configured losetup cannot be
     found.
   * Improving indices workaround by checking LH_BOOTSTRAP_FLAVOUR rather than
     LH_PACKAGES_LISTS in order to handle chicken-egg problem for installing
     apt-utils when having bootstrapped a minimal chroot.
   * Also accept x86_64 as alias for amd64 when checking for cross architecture
     support.
   * Adding virtualbox-ose hook.
   * Adding lh_chroot_selinuxfs helper to support building live images on a
     selinux enabled host (Closes: #501652).
   * Applying patch from Frederic Boiteux <fboiteux@calistel.com> to support
     wildcards in rootfs exclude lists (Closes: #500677).
   * Making removal stage of lh_chroot_selinuxfs dependent on the existence of
     /selinux, otherwise that directory would be always created in the chroot.
   * Manually setting owner of /etc/skel to root.
   * Making sure /etc/sudoers has right owner/permissions.
   * Using simplified Require_stagefile(); calls by passing multiple arguments.
   * Enforcing lh_config to be run before lh_build, see also
     http://lists.debian.org/debian-live/2008/10/msg00102.html (Closes: #500740).
   * Updating version number in common.sh.
   * Removing LIVE_* grep from Exit(); as we have switched to LH_* variables long
     time ago.
   * Adding unmount calls for pseudo-filesystems in Exit();.
   * Excluding ipppd from rescue list due to #502693.
   * Correcting intendation in conffile.sh.
   * Adjusting code style of lh_dumpconfig.
   * Merging lh_dumpconfig into lh_config as --dump parameter.
   * Updating Debian Forensics packages in rescue list.
   * Using dd rather than cat to write mbr.bin to usb-hdd images; dd is more
     robust in case mbr.bin is corrupted.
   * Improving version output of lh_config --dump.
   * Removing double cryptsetup entry in rescue list.
   * Adding lsof in rescue list.
   * Updating releases.sh to match internal namespace of included functions.
   * Marking grub and lilo in rescue list as amd64 and i386 only.
   * Grouping bootloaders in rescue list.
   * Adding hppa bootloader to rescue list.
   * Renaming internal Read_conffile(); to Read_conffiles(); for consistency
     reasons.
   * Generalizing internal Chroot(); by requiring its first argument to be the
     chroot directory.
   * Don't use set -e in sourced functions, this is the job of the actual
     executed script.
   * Check for availability of gettext at runtime, and only use it if existing.
   * Updating color functions.
   * Adding armel to architecture specific checks.
   * Slightly reordering genisoimage option assembling.
   * Slightely improving wording of the 'bootloader not yet supported' when
     creating images.
   * Updating signals in exit and lockfile traps.
   * Syncing internal lockfile functions.
   * Syncing internal l10n functions.
   * Generalizing internal LH_L10N variable.
   * Generalizing internal LH_FORCE variable.
   * Generalizing internal LH_DEBUG variable.
   * Generalizing internal LH_QUIET variable.
   * Generalizing internal LH_VERBOSE variable.
   * Generalizing internal LH_BREAKPOINTS variable.
   * Implementing colorful output (currently disabled by default, though).
   * Cleaning up code of 'lh' short helper.
   * Correcting manpage section reference in a comment in lh.
   * Removing double warning symbol.
   * Also checking for gettext catalogs to be installed before enabling l10n.
   * Using package variable to refere internally to live-helper.
   * Generalizing internal LH_CONFFILE variable.
   * Replacing obsolete dh_clean -k with dh_prep.
 .
   [ Marco Amadori ]
   * lh_config --help and manpage 'copy' mention.
   * Ensure lh_binary_debian-installer includes local debs (Closes: #502877)
 .
   [ Maximilian Gass ]
   * Only install memtest in lh_binary_syslinux if enabled.
 .
   [ Kai Hendry ]
   * Removing etch-only madwifi-doc package from madwifi example hook.
Checksums-Sha1: 
 503539d95abd9732802ac3590bbb5e16f536cdc9 1239 live-helper_1.0.1-2.dsc
 007e7ba6226bf6e4c0c5272ed243b30e0317d4b9 37922 live-helper_1.0.1-2.diff.gz
 76307a55ffcf95be88f53eaba267f02619ac6e5b 1857734 live-helper_1.0.1-2_all.deb
Checksums-Sha256: 
 09b455210ec0b4c539ac2dc9c9a5446badc7dc0f2da7bfb1cd31303d1207ba7e 1239 live-helper_1.0.1-2.dsc
 bbcddc8f632e649016f48f239160b336dfe680d1d180039e52946b739334aadb 37922 live-helper_1.0.1-2.diff.gz
 4be79b70b49db0da0953271273619b046ed21524a5d981e8d87d1300ea7b23c9 1857734 live-helper_1.0.1-2_all.deb
Files: 
 e39d82ca8ba3fa6037eb1b84d7e5a933 1239 misc optional live-helper_1.0.1-2.dsc
 124e698c02f4036b2bbcf31b97412a69 37922 misc optional live-helper_1.0.1-2.diff.gz
 01e07f1b7f0c201b3fd21764f125900c 1857734 misc optional live-helper_1.0.1-2_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkkZf0IACgkQ+C5cwEsrK55AtwCgxOEKq6zsl+jRfQxOpw83hK1K
rMUAoKuJOwERKH8mu/zrpjdxtVlNvGKS
=6xNN
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 17 Dec 2008 07:28:00 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 20:03:03 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.